#include <stdio.h>
#include <string.h>

#define MAXWORD	20

void intestazione(void)
{
	printf("  L  M  M  G  V  S  D\n");
	printf(" --------------------\n");
}

short numerogiorni(void)
{
	char nome[MAXWORD];
	short i;

	/* I seguenti due array sono dichiarati static per un motivo che vedremo piu' avanti. */
	/* A tutti gli effetti il programma funziona anche omettendo il qualificatore static */
	static char *mesi[] = {
		"gennaio", "febbraio", "marzo", "aprile", 
		"maggio", "giugno", "luglio", "agosto", 
		"settembre", "ottobre", "novembre", "dicembre"
	};
	static short giorni[] = {
		31,28,31,30,31,30,31,31,30,31,30,31
	};

	/* ciclo potenzialmente infinito: l'unico punto di uscita e' l'istruzione return giorni[i] */ 
	for(;;) { 
		printf("Inserisci il nome del mese:\n");
		scanf("%s",nome);
		for(i = 0; i < 12; i++)
			if(strcmp(nome,mesi[i])==0) 
				return giorni[i];
		printf("%s non e' il nome di un mese. Riprova.\n",nome);
	} 
	return 0;	
}

short giornoiniziale(void)
{
	char nome[MAXWORD];
	short i;

	/* Il seguente array e' dichiarato static per un motivo che vedremo piu' avanti. */
	/* A tutti gli effetti il programma funziona anche omettendo il qualificatore static */
	static char *giorni[] = {
		"lunedi", "martedi", "mercoledi", "giovedi", "venerdi", "sabato", "domenica"
	};

	/* ciclo potenzialmente infinito: l'unico punto di uscita e' l'istruzione return i+1 */ 
	for(;;) { 
		printf("Inserisci il nome del giorno iniziale del mese:\n");
		scanf("%s",nome);
		for(i = 0; i < 7; i++)
			if(strcmp(nome,giorni[i])==0) 
				return i+1;
		printf("%s non e' il nome di un giorno della settimana. Riprova.\n",nome);
	} 
	return 0;	

}

int main(void)
{
	short giorni = numerogiorni();
	short iniziale = giornoiniziale();

	/* calcolo il giorno in cui cade la prima domenica del mese */
	/* cio' mi serve per decidere quando andare a capo */
	short primadomenica = (8 - iniziale) % 7;

	short i;

	intestazione();

	/* stampo una sequenza di spazi iniziali per posizionare in modo corretto il primo giorno dl mese */
	for(i = 1; i < iniziale; i++)
		printf("   ");
	
	/* ciclo sui giorni del mese */
	for(i = 1; i <= giorni; i++) {
		printf("%3d",i);
		
		/* se i corrisponde a una domenica e non e' l'ultimo giorno del mese, vado a capo */
		if((i < giorni) && (i % 7 == primadomenica))
			putchar('\n');
	}
	putchar('\n');
	return 0;
}
