#include <stdio.h>

#define MAXDIM	80

short dec2base(short base, int d, char *b)
{
	short i = MAXDIM;
	int dd;
	
	b[MAXDIM] = 0;
	do {
		dd = d % base;
		/* conversione della cifra nel valore intero corrispondente: */
            /* se la cifra e' una fra 0,1,...,9 allora mi basta sommare '0' */
            /* se la cifra e' una lettera minuscola allora devo sommare 'a'-10 */
		b[--i] = dd + (dd <= 9 ? '0' : 'a'-10);
		d /= base;
	} while(d >= 1);
	return i;
}

int base2dec(short base, char *b)
{
	short i,c;
	int n = 0;

	for(i = 0; b[i]; i++) {
		/* conversione della cifra nel valore intero corrispondente: */
            /* se la cifra e' una fra 0,1,...,9 allora mi basta sottrarre '0' */
            /* se la cifra e' una lettera minuscola allora devo sotrrarre 'a'-10 */
		c = b[i] - (b[i] <= '9' ? '0' : 'a'-10);
		n *= base;
		n += c;
	}
	return n;
}

int main(void)
{
	int d;
	char b[MAXDIM + 1];
	short base;
	short i;

	printf("Immetti base in cui convertire (1 < base < 37):\n");
	if((scanf("%hd",&base) != 1) || base <= 1 || base >= 37) {
		fprintf(stderr, "Errore nell'immissione della base.\n");
		return -1;
	}	 
	printf("Immetti numero (nonnegativo) in base 10 da convertire in base %d:\n",base);
	if((scanf("%d",&d) != 1) || d < 0) {
		fprintf(stderr, "Errore nell'immissione del numero nonnegativo.\n");
		return -2;
	}
	i = dec2base(base,d,b);
	printf("%d in base 10 si scrive %s in base %d\n",d,&b[i],base);
	d = base2dec(base,&b[i]);
	printf("%s in base %d equivale a %d in base 10\n",&b[i],base,d);
	return 0;
}
