#include <stdio.h>


#define BLANK			' '
#define UPEDGE			'/'
#define DOWNEDGE		'\\'
#define TOPCORNER		'^'
#define BOTTOMCORNER		'v'
#define LEFTCORNER		'<'
#define RIGHTCORNER		'>'

/*
#define BLANK			' '
#define UPEDGE			'*'
#define DOWNEDGE		'*'
#define TOPCORNER		'*'
#define BOTTOMCORNER		'*'
#define LEFTCORNER		'*'
#define RIGHTCORNER		'*'
*/

void disegnalosanga(int lato)
{
	int i,j;

	/* ciclo su i per le prime (lato) linee */
	
	/* disegna quindi la meta' alta della losanga */
	
	/* linea mediana inclusa */
   
	/* nota: su ogni linea appaiono sempre 1 o 2 simboli diversi dallo spazio */
	for(i = 0;i < lato;i++) {

		
		/* ciclo su j per stampare gli spazi che precedono il primo simbolo diverso da spazio */
		for(j = lato - i;j;j--)
			printf("%c",BLANK);

	
		/* si deve stampare il simbolo, se i == 0 allora e' l'apice della losanga, */
		
		/* se invece i == lato-1, allora e' l'angolo sinistro */
		
		/* negli altri casi e' una parte del lato "ascendente" */
		printf("%c",i ? ((lato-i == 1) ? LEFTCORNER : UPEDGE) : TOPCORNER);

		/* ciclo su j per stampare gli spazi intermedi tra i 2 simboli diversi da spazio */
	
		/* nota: se si e' sulla 0-esima linea (i == 0), */
		
		/* allora 2*i - 1 == -1 e il ciclo non viene mai eseguito */
	
		for(j = 0;j < 2*i - 1;j++)
			printf("%c",BLANK);

		
		/* se i > 0 allora si stampa adesso il secondo simbolo diverso da spazio */
		if(i)
			
			/* se i == lato-1, allora e' l'angolo destro */
		
			/* altrimenti e' una parte del lato "discendente" */
			printf("%c",(lato-i == 1) ? RIGHTCORNER: DOWNEDGE);

		
		/* a questo punto l'i-esima riga e' stata disegnata e si va a capo */
		printf("%c",'\n');
	}

	
	/* ciclo su i per le ultime (lato-1) linee */

	/* disegna quindi la meta' bassa della losanga */
	for(i = lato-2;i >= 0;i--) {

		
		/* ciclo su j per stampare gli spazi che precedono il primo simbolo diverso da spazio */
		for(j = lato - i;j;j--)
			printf("%c",BLANK);
	

		/* si deve stampare il simbolo, se i == 0 allora e' il vertice "basso" della losanga, */
		/* negli altri casi e' una parte del lato "discendente" */
		printf("%c",i ? DOWNEDGE : BOTTOMCORNER);

	
		/* ciclo su j per stampare gli spazi intermedi tra i 2 simboli diversi da spazio */
		
		/* nota: se si e' sull'ultima linea (i == 0), */
	
		/* allora 2*i - 1 == -1 e il ciclo non viene mai eseguito */
		for(j = 0;j < 2*i - 1;j++)
			printf("%c",BLANK);

		
		/* se i > 0 allora si stampa adesso il secondo simbolo diverso da spazio */
		if(i)
			printf("%c",UPEDGE);

		
		/* a questo punto l'i-esima riga e' stata disegnata e si va a capo */
		printf("%c",'\n');
	}
}


/* versione in cui si utilizza putchar(carattere) al posto di printf("%c",carattere) */

/*
void disegnalosanga(int lato)
{
	int i,j;

	for(i = 0;i < lato;i++) {
		for(j = lato - i;j;j--)
			putchar(BLANK);
		putchar(i ? ((lato-i == 1) ? LEFTCORNER : UPEDGE) : TOPCORNER);
		for(j = 0;j < 2*i - 1;j++)
			putchar(BLANK);
		if(i)
			putchar((lato-i == 1) ? RIGHTCORNER: DOWNEDGE);
		putchar('\n');
	}
	for(i = lato-2;i >= 0;i--) {
		for(j = lato - i;j;j--)
			putchar(BLANK);
		putchar(i ? DOWNEDGE : BOTTOMCORNER);
		for(j = 0;j < 2*i - 1;j++)
			putchar(BLANK);
		if(i)
			putchar(UPEDGE);
		putchar('\n');
	}
}

*/


int main(void)
{
	int lato = 0;

	printf("Inserisci la lunghezza del lato:\n");
	scanf("%d",&lato);
	disegnalosanga(lato);
	return 0;
}

