#include <stdio.h>

/* provate a modificare il valore di LATO e ricompilare */
#define LATO	3

#define PLAYER1	'*'
#define PLAYER2	'o'
#define BLANK	' '
#define ROW		'-'
#define COL		'|'

#define posto(i,j)  (LATO * (i) + (j))

/* per buttare la parte non ancora letta di una linea di input */
#define svuotainput()	while(getchar() != '\n')

void stampatavola(char *tavola)
{
	short i,j,k;
	char c;

      /* la cornice e' composta da (LATO * 2 + 1) trattini */
	for(k = 0;k <= LATO * 2;k++)
		putchar(ROW);
	putchar('\n');
	for(i = 0; i < LATO; i++) {
		for(j = 0; j < LATO; j++) {
			c = tavola[posto(i,j)];
			putchar(COL);
			putchar(c ? (c == 1 ? PLAYER1 : PLAYER2) : BLANK);
		}
		putchar(COL);
		putchar('\n');
		for(k = 0;k <= LATO * 2;k++)
			putchar(ROW);
		putchar('\n');

	}
}

void puliscitavola(char *tavola)
{
	short i,j;

	for(i = 0;i < LATO;i++)
		for(j = 0;j < LATO;j++)
			tavola[posto(i,j)] = 0;
}

void eseguimossa(char *tavola, char giocatore, short i, short j)
{
	if(!tavola[posto(i,j)])
		tavola[posto(i,j)] = giocatore;
}

char neilimiti(short x, short y)
{
	return (x >= 0) && (x < LATO) && (y >= 0) && (y <= LATO);
}

char mossalegale(char *tavola, short x, short y)
{
	return neilimiti(x,y) && !tavola[posto(x,y)];
}

/* Nota che px e py sono puntatori a short: passaggio parametri per riferimento */
void inputmossa(char *tavola, char giocatore, short *px, short *py)
{
	while(1) {
		printf("Giocatore %d: muovi:\n",giocatore);
		/* scanf ritorna 2 se ha effetivamente letto 2 interi */
		if((scanf("%hd %hd",px,py) == 2) && mossalegale(tavola,*px,*py)) {
			svuotainput();
			return;
		}
		printf("Input scorretto, riprovaci.\n");
		svuotainput();
	}
}

/* restituisce 1 se la riga i-esima e' tutta occupata dal giocatore, 0 altrimenti */
char controllariga(char *tavola, char giocatore, short i)
{
	short j;

	for(j = 0;j < LATO;j++)
		/* restituisce 0 non appena trova una casella non occupata da giocatore */
		if(!(tavola[posto(i,j)] == giocatore))
			return 0;
	return 1; 
}

/* restituisce 1 se la colonna i-esima e' tutta occupata dal giocatore, 0 altrimenti */
char controllacolonna(char *tavola, char giocatore, short i)
{
	short j;

	for(j = 0;j < LATO;j++)
		/* restituisce 0 non appena trova una casella non occupata da giocatore */
		if(!(tavola[posto(j,i)] == giocatore))
			return 0;
	return 1; 
}

/* restituisce 1 se la diagonale e' tutta occupata dal giocatore, 0 altrimenti */
char controlladiagonale(char *tavola, char giocatore)
{
	short j;

	for(j = 0;j < LATO;j++)
		/* restituisce 0 non appena trova una casella non occupata da giocatore */
		if(!(tavola[posto(j,LATO-1-j)] == giocatore))
			return 0; 
	return 1;
}

/* restituisce 1 se la controdiagonale e' tutta occupata dal giocatore, 0 altrimenti */
char controllacontrodiagonale(char *tavola, char giocatore)
{
	short j;

	for(j = 0;j < LATO;j++)
		/* restituisce 0 non appena trova una casella non occupata da giocatore */
		if(!(tavola[posto(j,j)] == giocatore))
			return 0; 
	return 1;
}

/* per ogni giocatore, restituisce giocatore non appena trova un tris del giocatore, */
/* altrimenti restituisce 0 */
char havinto(char *tavola)
{
	char giocatore;
	short i;

	for(giocatore = 1;giocatore <= 2;giocatore++) {
		for(i = 0;i < LATO;i++) {
			if(controllacolonna(tavola,giocatore,i))
				return giocatore;
			if(controllariga(tavola,giocatore,i))
				return giocatore; 
		}
		if(controlladiagonale(tavola,giocatore))
			return giocatore;
		if(controllacontrodiagonale(tavola,giocatore))
			return giocatore;
	}
	return 0;
}

/* restituisce 1 se la tavola non contiene caselle libere. */
/* in alternativa, basta controllare il numero di mosse effettuate: */
/* ESERCIZIO: implementare la soluzione alternativa con prototipo: */
/* char tavolapiena(short numeromosse) */
char tavolapiena(char *tavola)
{
	short i,j;

	for(i = 0; i < LATO; i++)
		for(j = 0; j < LATO; j++)
			if(!tavola[posto(i,j)])
				return 0;
	return 1; 
}

void partita(void)
{
	/* Nota: LATO * LATO e' valore noto a tempo di compilazione, dunque */
      /* si puo' dimensionare tavola con questa espressione */
	char tavola[LATO * LATO];
	short x,y;
	char mossa = 0;
	char giocatore;

	puliscitavola(tavola);
	stampatavola(tavola);
	while(!havinto(tavola) && !tavolapiena(tavola)) {
		/* usando l'operatore % (resto della divisione intera) */
            /* determiniamo facilmente quale giocatore deve muovere */
		giocatore = (mossa % 2 + 1);
		printf("Mossa numero %d: ",++mossa);
		inputmossa(tavola,giocatore,&x,&y);
		eseguimossa(tavola,giocatore,x,y);
		stampatavola(tavola);
	}
	if((giocatore = havinto(tavola)))
		printf("Ha vinto il giocatore %d!\n", giocatore);
	else
		printf("Partita conclusa in pareggio\n");
}

int main(void)
{
	char risposta;

	do {
		partita();
		printf("Un'altra partita? (s/n)\n");
		scanf("%c",&risposta);
		svuotainput();
	} while(risposta == 's');
	return 0;
}
